' MakeCAB.VBS V1.01 (C) yoshioka.teruo@nifty.com 2006-01-07
' MakeCAB.VBS makes CAB file of files.
' Usage: Start MakeCAB.VBS files...

Option Explicit
Const ssfBITBUCKET=10'shell:RecycleBinFolder::{645FF040-5081-101B-9F08-00AA002F954E}
Dim optind
Dim fso
Dim CABfile
Dim dic
Dim Path
Dim File
Dim MakeCab
Dim Shell
Dim zFolder
Dim zFolderItem
Dim tFolderName
Dim tFolder
Dim tFolderItem

If WScript.Arguments.Count<1 Then
  WScript.Echo "Usage: Start MakeCAB.VBS files..."
  WScript.Quit
End If

Set fso=CreateObject("Scripting.FileSystemObject")
CABfile=WScript.Arguments(0)
If UCase(fso.GetExtensionName(CABfile))="CAB" Then
  optind=1
Else
  CABfile=fso.BuildPath(fso.GetParentFolderName(CABfile),fso.GetBaseName(CABfile)&".CAB")
End If

If WScript.Arguments.Count<optind+1 Then
  WScript.Echo "Arguments Missing."
  WScript.Quit
End If

CABfile=fso.GetAbsolutePathName(CABfile)
Set dic=CreateObject("Scripting.Dictionary")
For optind=optind To WScript.Arguments.Count-1
  Path=WScript.Arguments.Item(optind)
  File=LCase(fso.GetFileName(Path))
  If dic.Exists(File) Then
    WScript.Echo File,"- Duplicate Names."
    WScript.Quit
  End If
  If Not fso.FileExists(Path) Then
    WScript.Echo Path,"- Not Found."
    WScript.Quit
  End If
  Path=fso.GetAbsolutePathName(Path)
  dic.Add File,Path
Next
Set MakeCab=CreateObject("MakeCab.MakeCab.1") 
If fso.FileExists(CABfile) Then
  Set Shell=CreateObject("Shell.Application")
  Set zFolder=Shell.NameSpace(CABfile)
  tFolderName=fso.BuildPath(fso.GetParentFolderName(CABfile),fso.GetTempName)
  fso.CreateFolder tFolderName
  Set tFolder=Shell.NameSpace(tFolderName)
  For Each zFolderItem In zFolder.Items()
    If dic.Exists(LCase(fso.GetFileName(zFolderItem.Path))) Then
    Else
      tFolder.CopyHere zFolderItem
    End If
  Next
  Set zFolder=Nothing
  Shell.NameSpace(ssfBITBUCKET).MoveHere CABfile
  Do While fso.FileExists(CABfile)
    WScript.Sleep 100
  Loop
  MakeCab.CreateCab (CABfile),False,False,False 
  For Each tFolderItem In tFolder.Items()
    MakeCab.AddFile tFolderItem.Path,fso.GetFileName(tFolderItem.Path)
  Next
  fso.DeleteFolder tFolderName
Else
  MakeCab.CreateCab (CABfile),False,False,False 
End If
For Each File In dic
  MakeCab.AddFile (dic.Item(File)),(File)
Next
MakeCab.CloseCab 
