' PasteCAB.VBS V1.01 (C) yoshioka.teruo@nifty.com 2006-01-07
' PasteCAB.VBS pastes copied files to CAB file.
' Usage: Start PasteCAB.VBS [CABfile]

Option Explicit
Dim CABfile
Dim Shell

If WScript.Arguments.Count=0 Then
  Call ParentProcess()
ElseIf WScript.Arguments.Count=1 And LCase(Right(WScript.Arguments.Item(0),4))=".cab" Then
  Call ParentProcess()
Else
  Call ChildProcess()
End If
WScript.Quit

Sub ChildProcess()
Dim k:k=0
Dim args():ReDim args(WScript.Arguments.Count-1)
For k=0 To WScript.Arguments.Count-1
  args(k)=WScript.Arguments(k)
Next
Call PutClipByMsIE(Join(args,vbCrLf))
End Sub

Sub ParentProcess()
Const OLECMDID_PASTE = 13
Const OLECMDEXECOPT_DODEFAULT = 0
Dim Folder
Dim FolderItem
Dim Verb
Dim k
Dim Text
Dim ie

Set Shell=CreateObject("Shell.Application")
If WScript.Arguments.Count Then
  CABfile=WScript.Arguments.Item(0)
Else
  Set ie=Shell.Windows().Item()
  If ie.ReadyState<>4 Then
  ElseIf ie.Busy Then
  ElseIf InStr(TypeName(ie.Document),"IShellFolderView")=0 Then
  ElseIf LCase(Right(ie.Document.Folder.Self.Path,4))=".cab" Then
    CABfile=ie.Document.Folder.Self.Path
  ElseIf ie.Document.SelectedItems().Count=1 Then
    CABfile=ie.Document.SelectedItems().Item(0).Path
  End If
  If IsEmpty(CABfile) Then
    WScript.Echo "\tCABt@CIĂ܂B"
    WScript.Quit
  End If
End If

Set Folder=Shell.NameSpace(Left(WScript.ScriptFullName,InStrRev(WScript.ScriptFullName,"\")))
Set FolderItem=Folder.Items().Item(WScript.ScriptName)
For Each Verb In FolderItem.Verbs()
  If Verb.Name="\t(&P)" Then Exit For
Next
If IsEmpty(Verb) Then
  WScript.Echo "\tt@C܂B"
  WScript.Quit
End If
Verb.DoIt

Set ie=CreateObject("InternetExplorer.Application")
'ie.Visible=true
ie.Navigate "about:blank"
Do While ie.Busy Or ie.ReadyState<>4
  WScript.Sleep 100
Loop
ie.Document.write "<html><body><textarea id=txt></textarea></body></html>"
ie.Document.all.txt.focus
For k=1 To 100
  WScript.Sleep 100
  Call ie.ExecWB(OLECMDID_PASTE,OLECMDEXECOPT_DODEFAULT)
  Text=ie.document.all.txt.Value
  If Text<>"" Then Exit For
Next
ie.Quit 
If Text="" Then
  WScript.Echo "Failed. Timed Out."
  WScript.Quit
End If
Call CreateCab(Split(Text,vbCrLf))
End Sub

Sub CreateCAB(Files)
Const ssfBITBUCKET=10'shell:RecycleBinFolder::{645FF040-5081-101B-9F08-00AA002F954E}
Dim fso
Dim dic
Dim Path
Dim File
Dim MakeCab
Dim Shell
Dim zFolder
Dim zFolderItem
Dim tFolderName
Dim tFolder
Dim tFolderItem

If UBound(Files)<0 Then
  WScript.Echo "Arguments Missing."
  WScript.Quit
End If

Set fso=CreateObject("Scripting.FileSystemObject")
If UCase(fso.GetExtensionName(CABfile))<>"CAB" Then
  WScript.Echo "Invalid Extension Name -",fso.GetFileName(CABfile)
  WScript.Quit
End If
Set dic=CreateObject("Scripting.Dictionary")
For Each Path In Files
  File=LCase(fso.GetFileName(Path))
  If dic.Exists(File) Then
    WScript.Echo File,"- Duplicate Names."
    WScript.Quit
  End If
  If Not fso.FileExists(Path) Then
    WScript.Echo Path,"- Not Found."
    WScript.Quit
  End If
  Path=fso.GetAbsolutePathName(Path)
  dic.Add File,Path
Next
Set MakeCab=CreateObject("MakeCab.MakeCab.1") 
If fso.FileExists(CABfile) Then
  Set Shell=CreateObject("Shell.Application")
  Set zFolder=Shell.NameSpace(CABfile)
  tFolderName=fso.BuildPath(fso.GetParentFolderName(CABfile),fso.GetTempName)
  fso.CreateFolder tFolderName
  Set tFolder=Shell.NameSpace(tFolderName)
  For Each zFolderItem In zFolder.Items()
    If dic.Exists(LCase(fso.GetFileName(zFolderItem.Path))) Then
    Else
      tFolder.CopyHere zFolderItem
    End If
  Next
  Set zFolder=Nothing
  Shell.NameSpace(ssfBITBUCKET).MoveHere CABfile
  Do While fso.FileExists(CABfile)
    WScript.Sleep 100
  Loop
  MakeCab.CreateCab (CABfile),False,False,False 
  For Each tFolderItem In tFolder.Items()
    Path=tFolderItem.Path
    File=fso.GetFileName(Path)
    MakeCab.AddFile (Path),(File)
  Next
  fso.DeleteFolder tFolderName
Else
  MakeCab.CreateCab (CABfile),False,False,False 
End If
For Each File In dic
  MakeCab.AddFile (dic.Item(File)),(File)
Next
MakeCab.CloseCab 
End Sub

Function PutClipByMsIE(Text)
Const OLECMDID_COPY = 12
Const OLECMDID_SELECTALL = 17 '(&H11)
Const OLECMDEXECOPT_DODEFAULT = 0
Dim ie
Set ie=CreateObject("InternetExplorer.Application")
'ie.Visible=true
ie.Navigate "about:blank"
Do While ie.Busy Or ie.ReadyState<>4
  WScript.Sleep 100
Loop
ie.Document.Body.InnerText=Text
ie.ExecWB OLECMDID_SELECTALL,OLECMDEXECOPT_DODEFAULT
ie.ExecWB OLECMDID_COPY,OLECMDEXECOPT_DODEFAULT
ie.Quit 
End Function
